(* let attendance = "please react with :exploding_head: to the attendance message"

let cupOfTea (wallet : float) = (wallet - 3.0, brew ())

let (wallet', tea) = cupOfTea 100.0

(* suppose you are Stephen Brookes *)

let fromGBP : float -> float = fun n -> n * 1.37
let cupOfTeaGBP = cupOfTea o fromGBP

(* First cut *)

type usd = float
type gbp = float

let fromGBP (gbp : gbp) : usd = gbp * 1.37

let _ = fromGBP (blah : usd)

(* Second cut *)
type usd = USD of float
type gbp = GBP of float

let fromGBP (GBP amount) = USD (amount * 1.37)

let addUSD (USD amount1) (USD amount2) = USD (amount1 + amount2)
let addGBP (GBP amount1) (GBP amount2) = GBP (amount1 + amount2)

type usd = DividingByZero
type gbp = Foo

type 'a wallet = Wallet of 'a * float

(* gbp <> usd ! ! ! *)
let fromGBP (Wallet (_, amount) : gbp wallet) : usd wallet = Wallet (amount * 1.37)

let _ = fromGBP (blah : usd wallet)

let addWallets (Wallet amount1 : 'a wallet) (Wallet amount2 : 'a wallet) : 'a wallet =
  Wallet (amount1 + amount2)

type ('a, 'b) exchange = Exchange of float

let convert (Exchange ratio : ('a, 'b) exchange) (Wallet amount : 'a wallet) : 'b wallet =
  Wallet (ratio * amount)

type cad

let exchangeGBPToUSD : (gbp, usd) exchange = Exchange 1.37
let exchangeCADToUSD : (cad, usd) exchange = Exchange 1.33

let fromCAD = convert exchangeCADToUSD


 *)

module type ARRAY = sig
  type 'a t

  val fromList : 'a list -> 'a t
  val fromInt : int -> bool t
  val get : int -> 'a t -> 'a
end

module Array : ARRAY = struct
  type 'a t =
    | List : 'a list -> 'a t
    | Int : int -> bool t

  let fromList l = List l
  let fromInt i = Int i

  let get (type a) (i : int) (a : a t) =
    match a with
    | List l -> List.nth l i
    | Int n -> n == 0
  ;;

  let toString (array : char t) : string =
    match array with
    | List _ -> failwith "todo"
  ;;
end

(* type 'a option =
  | NONE
  | SOME of 'a *)

type 'a option =
  | NONE : 'a option
  | SOME : 'a -> 'a option

type z = |
type 'n s = |

type ('a, 'n) list =
  | Nil : ('a, z) list
  | Cons : 'a * ('a, 'n) list -> ('a, 'n s) list

let head (l : ('a, 'n s) list) : 'a =
  match l with
  | Cons (x, _) -> x
;;

(* let rec zip (type n) (l1 : ('a, n) list) (l2 : ('b, n) list) : ('a * 'b, n) list =
  match l1, l2 with
  | Nil, Nil -> Nil
  | Cons (x, (xs : ('a, 'm) list)), Cons (y, (ys : ('b, 'm) list)) ->
    Cons ((x, y), zip (type 'm) xs ys)
;; *)

(* let append (l1 : ('a, 'm) list) (l2 : ('a, 'n) list) :  *)

(* | _ -> failwith "lists are not the same length" *)

type red = |
type black = |

type ('a, 'color, 'n) tree =
  | Empty : ('a, black, z) tree
  | Red : ('a, black, 'n) tree * ('a, black, 'n) tree * 'a -> ('a, red, 'n) tree
  | Black : ('a, 'c1, 'n) tree * ('a, 'c2, 'n) tree * 'a -> ('a, black, 'n s) tree

(* Typing the Coding Interview *)
